#!/bin/bash
# Result code: 1 (miss instances (and connections)), 2 (miss connections)
ADML_CONNECTIONS=`cat .st_conf_adml_connections 2>/dev/null`
ADML_INSTANCES=`cat .st_conf_adml_instances 2>/dev/null`
RESULT_CODE=0

cd $(dirname $0)
if [ -z "$ADML_CONNECTIONS" -o -z "$ADML_INSTANCES" ]
then
  echo
  echo "Run './configure.sh' first !"
  echo
  exit 3
fi

echo -n "Checking instances ... "
ADML_INSTANCES_ALIVE=$(pgrep "ADML-[0-9]" | wc -l)
echo -n "$ADML_INSTANCES_ALIVE instances alive"
if [ $ADML_INSTANCES_ALIVE -lt $ADML_INSTANCES ]
then
  echo " ! (expected $ADML_INSTANCES configured)"
  RESULT_CODE=1
else
  echo
fi

cmd="netstat -a | grep :diameter | grep ESTABLISHED | wc -l"
echo -n "Checking connections ... "
ADML_CONNECTIONS_ALIVE=$(eval $cmd)
ADML_TOTAL_CONNECTIONS=$((ADML_CONNECTIONS*ADML_INSTANCES))
echo -n "$ADML_CONNECTIONS_ALIVE connections established (using '$cmd')"
if [ $ADML_CONNECTIONS_ALIVE -ne $ADML_TOTAL_CONNECTIONS ]
then
  echo " ! (expected $ADML_TOTAL_CONNECTIONS configured)"
  [ $RESULT_CODE -ne 1 ] && RESULT_CODE=2
else
  echo
fi

echo
echo "Check CEAs doing something like this:"
echo "   ./operation.sh show-oam | grep CEAReceived | grep AccumulatedAmount > ceas.txt; cat ceas.txt | cut -d\\\" -f12 | paste -sd+ | bc"
echo

exit $RESULT_CODE

