// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_diameter_codec_tme_Message_hpp
#define anna_diameter_codec_tme_Message_hpp


// Local
#include <anna/diameter/codec/Message.hpp>
#include <anna/diameter/codec/tme/Avp.hpp>


//------------------------------------------------------------------------------
//---------------------------------------------------------------------- #define
//------------------------------------------------------------------------------

namespace anna {

namespace diameter {

namespace codec {

namespace tme {

class Avp;
//class Engine;

/**
* Diameter TME message generic container
* Manages tme-specific formats (Unsigned16, ISDNAddress, ISDNNumber)
* </pre>
*/
class Message : public anna::diameter::codec::Message {

protected:

//  /** Codec Engine getter: avoids have to create base engine when using its child */
//  virtual anna::diameter::codec::Engine * getEngine() const throw(anna::RuntimeException);

  /**
  * Initializes Message class information.
  * Any reimplementation must first invoke base class method.
  */
  virtual void initialize() throw();

public:

  /**
  * Default constructor
  * @param engine Codec engine used
  */
  Message(Engine *engine = NULL) : anna::diameter::codec::Message(engine) {;}

  /**
  * Identified constructor
  * @param id Command identifier as pair (code,request-indicator).
  * @param engine Codec engine used
  */
  Message(CommandId id, Engine *engine = NULL) : anna::diameter::codec::Message(id, engine) {;}



};

}
}
}
}


#endif
