// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_xml_Text_hpp
#define anna_xml_Text_hpp

#include <anna/core/Allocator.hpp>

#include <anna/xml/Data.hpp>

namespace anna {

namespace xml {

/**
   Texto de nodo XML.

   Cada nodo XML puede tener un texto libre asociado. Por ejemplo:

   \code
      <broadcast>
         <INetAddress>
            <Address>204.152.65.15</Address>
            <Port>2000</Port>
         </INetAddress>
      </broadcast>
   \endcode
*/
class Text : public Data {
public:
  /**
     Devuelve una cadena con toda la informacion relevante de esta instancia.
     \return Una cadena con toda la informacion relevante de esta instancia.
  */
  std::string asString() const throw() {
    std::string result("xml::Text {");
    result += Data::asString();
    return result += " }";
  }

private:
  /* Para evitar que se pueda crear desde el exterior */
  Text() : Data() {;}
  
  virtual ~Text() {;}

  friend class Node;
  friend class Allocator<Text>;
};

}
}

#endif
