// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


// Local
#include <anna/diameter/codec/basetypes/Float64.hpp>


//------------------------------------------------------------------------------
//--------------------------------------------------------- Float64::codeBasic()
//------------------------------------------------------------------------------
void anna::diameter::codec::basetypes::Float64::codeBasic(char* buffer, int &size) throw(anna::RuntimeException) {
  /*buffer=*/
  anna::comm::functions::codeDouble(buffer, a_value);
  size = getSize();
}


//------------------------------------------------------------------------------
//------------------------------------------------ Float64::setPrintableString()
//------------------------------------------------------------------------------
void anna::diameter::codec::basetypes::Float64::setPrintableString(const char * printableString) throw(anna::RuntimeException) {
  setValue(atof/*strtod*/(printableString));
}


//------------------------------------------------------------------------------
//------------------------------------------------------------ Float64::decode()
//------------------------------------------------------------------------------
void anna::diameter::codec::basetypes::Float64::decode(const char* buffer, const int size) throw(anna::RuntimeException) {
  if(!buffer)
    throw anna::RuntimeException("Float64::decode | Null Buffer provided", ANNA_FILE_LOCATION);

  if(size != 8)
    throw anna::RuntimeException("Float64::decode | Buffer length must be 8 bytes", ANNA_FILE_LOCATION);

  a_value = anna::comm::functions::decodeDouble(buffer);
}

