// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


// Local
#include <anna/diameter/codec/basetypes/Unsigned32.hpp>


//------------------------------------------------------------------------------
//------------------------------------------------------ Unsigned32::codeBasic()
//------------------------------------------------------------------------------
void anna::diameter::codec::basetypes::Unsigned32::codeBasic(char* buffer, int &size) throw(anna::RuntimeException) {
  buffer[0] = (char)(a_value >> 24);
  buffer[1] = (char)(a_value >> 16);
  buffer[2] = (char)(a_value >> 8);
  buffer[3] = (char)a_value;
  size = getSize();
}


//------------------------------------------------------------------------------
//--------------------------------------------- Unsigned32::setPrintableString()
//------------------------------------------------------------------------------
void anna::diameter::codec::basetypes::Unsigned32::setPrintableString(const char * printableString) throw(anna::RuntimeException) {
  setValue(atoi(printableString));
}


//------------------------------------------------------------------------------
//--------------------------------------------------------- Unsigned32::decode()
//------------------------------------------------------------------------------
void anna::diameter::codec::basetypes::Unsigned32::decode(const char* buffer, const int size) throw(anna::RuntimeException) {
  if(!buffer)
    throw anna::RuntimeException("Unsigned32::decode | Null Buffer provided", ANNA_FILE_LOCATION);

  if(size != 4)
    throw anna::RuntimeException("Unsigned32::decode | Buffer length must be 4 bytes", ANNA_FILE_LOCATION);

  a_value = (((U32)buffer[0] << 24) & 0xFF000000) +
            (((U32)buffer[1] << 16) & 0x00FF0000) +
            (((U32)buffer[2] << 8)  & 0x0000FF00) +
            ((U32)buffer[3]         & 0x000000FF);
}

