// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#include <anna/core/tracing/Logger.hpp>
#include <anna/core/tracing/TraceMethod.hpp>
#include <anna/config/defines.hpp>
#include <anna/core/functions.hpp>

#include <anna/io/functions.hpp>

#include <libxml/HTMLparser.h>

#include <anna/html/DocumentFile.hpp>

using namespace std;
using namespace anna;

_xmlDoc* html::DocumentFile::do_initialize(const char* filename)
throw(RuntimeException) {
  LOGMETHOD(TraceMethod tf("anna::html::DocumentFile", "do_initialize", ANNA_FILE_LOCATION));
  _xmlDoc* result = NULL;
  a_filename = filename;
  LOGDEBUG(
    string msg("html::DocumentFile::do_initialize | Filename: ");
    msg += filename;
    Logger::debug(msg, ANNA_FILE_LOCATION);
  );

  if(io::functions::exists(filename) == false) {
    string msg("html::DocumentFile::do_initialize | File: ");
    msg += filename;
    msg += " | Not found";
    throw RuntimeException(msg, ANNA_FILE_LOCATION);
  }

  result = htmlParseFile(filename, NULL);

  if(result == NULL)
    throw RuntimeException(functions::asString("Error analyzing HTML document: %s", filename), ANNA_FILE_LOCATION);

  return result;
}

_xmlDoc* html::DocumentFile::do_initialize(const anna::DataBlock&)
throw(RuntimeException) {
  throw RuntimeException("html::DocumentFile::do_initialize | Not implemented", ANNA_FILE_LOCATION);
  return NULL;
}
