// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#include <iostream>

#include <limits.h>

#include <anna/config/Release.hpp>
#include <anna/core/util/defines.hpp>

#include <gtest/gtest.h>


using namespace std;
using namespace anna;

TEST(config, release) {
  string version = config::Release::getVersion();
  cout << version << endl;
  EXPECT_TRUE(version.empty() == false);
  int debug = version.find("/D");
  int release = version.find("/O");
#ifdef _DEBUG
  EXPECT_TRUE(debug != string::npos);
  EXPECT_TRUE(release == string::npos);
#else
  EXPECT_TRUE(debug == string::npos);
  EXPECT_TRUE(
    release != string::npos);
#endif
}

TEST(config, numbers) {
  S64 ii64;
  ii64 = LLONG_MAX;
  EXPECT_EQ(ii64, LLONG_MAX);
  ii64 = LLONG_MIN;
  EXPECT_EQ(ii64, LLONG_MIN);
  U64 u64;
  u64 = ULLONG_MAX;
  EXPECT_EQ(u64, ULLONG_MAX);
}

int main(int argc, char **argv)
{
    testing::InitGoogleTest(&argc, argv);
    return RUN_ALL_TESTS();
}

